//Controls 5 x propellers from a single propplug.

module	propplug_manager

(

input pb_reset,
input pb_prop_select,
input	[7:0] prop0_cog_ind,
input	[7:0] prop1_cog_ind,
input	[7:0] prop2_cog_ind,
input	[7:0] prop3_cog_ind,
input	[7:0] prop4_cog_ind,
input propplug_resn,
input propplug_rx,
input prop0_tx,
input prop1_tx,
input prop2_tx,
input prop3_tx,
input prop4_tx,

output [7:0] cog_status_leds,
output [6:0] prop_7_seg,
output prop0_resn,
output prop0_rx,
output prop1_resn,
output prop1_rx,
output prop2_resn,
output prop2_rx,
output prop3_resn,
output prop3_rx,
output prop4_resn,
output prop4_rx,
output propplug_tx,
output [6:0] cogs_used
);


reg [3:0] selected_prop;
reg [3:0] cogs_inuse;

initial selected_prop = 0;


//select a propeller and display on 7 segment display
always @(posedge pb_prop_select) begin;

	selected_prop++;
	if (selected_prop == 5) selected_prop <= 0;
end

always @(*) begin;

	if (selected_prop == 0) prop_7_seg <= ~7'b0111111;
	if (selected_prop == 1) prop_7_seg <= ~7'b0000110;
	if (selected_prop == 2) prop_7_seg <= ~7'b1011011;
	if (selected_prop == 3) prop_7_seg <= ~7'b1001111;
	if (selected_prop == 4) prop_7_seg <= ~7'b1100110;
	if (selected_prop == 5) prop_7_seg <= ~7'b1101101;
	
end

always @(*) begin;

	if (cogs_inuse == 0) cogs_used <= ~7'b0111111;
	if (cogs_inuse == 1) cogs_used <= ~7'b0000110;
	if (cogs_inuse == 2) cogs_used <= ~7'b1011011;
	if (cogs_inuse == 3) cogs_used <= ~7'b1001111;
	if (cogs_inuse == 4) cogs_used <= ~7'b1100110;
	if (cogs_inuse == 5) cogs_used <= ~7'b1101101;
	if (cogs_inuse == 6) cogs_used <= ~7'b1111101;
	if (cogs_inuse == 7) cogs_used <= ~7'b0000111;
	if (cogs_inuse == 8) cogs_used <= ~7'b1111111;

end


always @(*) begin;


		if (selected_prop == 0) cog_status_leds = prop0_cog_ind;
		if (selected_prop == 1) cog_status_leds = prop1_cog_ind;
		if (selected_prop == 2) cog_status_leds = prop2_cog_ind;
		if (selected_prop == 3) cog_status_leds = prop3_cog_ind;
		if (selected_prop == 4) cog_status_leds = prop4_cog_ind;


//		cog_status_leds <= (prop0_cog_ind) & (selected_prop == 0)
//		| (prop1_cog_ind) & (selected_prop == 1)
//		| (prop2_cog_ind) & (selected_prop == 2)
//		| (prop3_cog_ind) & (selected_prop == 3)
//		| (prop4_cog_ind) & (selected_prop == 4);
		
end

always @(*) begin;
		
		cogs_inuse <= cog_status_leds[0]
		+ cog_status_leds[1]
		+ cog_status_leds[2]
		+ cog_status_leds[3]
		+ cog_status_leds[4]
		+ cog_status_leds[5]
		+ cog_status_leds[6]
		+ cog_status_leds[7];

end

always @(*) begin;

	prop0_resn <= !(selected_prop == 0) | propplug_resn & pb_reset;
	prop0_rx <= !(selected_prop == 0) | propplug_rx;
	
	prop1_resn <= !(selected_prop == 1) | propplug_resn & pb_reset;
	prop1_rx <= !(selected_prop == 1) | propplug_rx;
	
	prop2_resn <= !(selected_prop == 2) | propplug_resn & pb_reset;
	prop2_rx <= !(selected_prop == 2) | propplug_rx;
	
	prop3_resn <= !(selected_prop == 3) | propplug_resn & pb_reset;
	prop3_rx <= !(selected_prop == 3) | propplug_rx;
	
	prop4_resn = !(selected_prop == 4) | propplug_resn & pb_reset;
	prop4_rx = !(selected_prop == 4) | propplug_rx;
	
	propplug_tx <= (!(selected_prop == 0) || prop0_tx)
	& (!(selected_prop == 1) || prop1_tx)
	& (!(selected_prop == 2) || prop2_tx)
	& (!(selected_prop == 3) || prop3_tx)
	& (!(selected_prop == 4) || prop4_tx);
	
end


endmodule

