{{
********************************************
*  DE2-115 FPGA P1V : 5 x Propeller demo   *
********************************************

Propeller #0 I/O assignments

Lcd Display

  pb7..0        lcd_data7..0
  pb8           lcd_rs
  pb9           lcd_rw
  pb10          lcd_e
  pb11          lcd_on
  
Propplug #2
  pa0           propplug #2 rx_in
  pa1           propplug #2 tx_out
  


}}


con

    clearscreen = %00000001
    home = %00000010

  _clkmode = xtal1 + pll16x
  _clkfreq = 120_000_000

  baud_rate = 19_200
  
  on = 11

obj

p1:     "prop1"
p2:     "prop2"
p3:     "prop3"
p4:     "prop4"
  
var

  long  sysclkfreq,_rs,_rw,_e,_db7,_db4
  long  mystack[20]

  byte  output_select
    
pub main

  coginit(6,p0_test,@mystack)
  
  outb~
  dirb := $fff
  outb[on] := 1
  
  waitcnt(cnt + clkfreq)
  init(clkfreq,8,9,10,7,4)

  repeat
  
      cls
      print(string("DE2-115 P1V Test"))
      cursor(1,0)
      print(string("40 Cogs @ "))
      lcd_dec(clkfreq / 1_000_000)
      print(string("MHz"))
      waitcnt(cnt + clkfreq * 5)
      
      cls
      print(string("   OZPROPDEV"))
      cursor(1,0)
      print(string("    was here"))
      waitcnt(cnt + clkfreq * 5)


  
pub p0_test|cog_number
  
  outa[1] := 1
  dira[1] := 1
    
  cog_number := cogid
  
  repeat
  
     waitcnt(cnt + clkfreq)
     message(string("Hello world from Prop#0 : Cog#"))
     output_select := 1
     dec(cog_number)
     message(string(" @ "))
     dec(baud_rate)
     message(string(" baud"))
     tx_out(13)
     
pub message(q)

    repeat strsize(q)
       tx_out(byte[q++])
       
pub tx_out(c)|x,t,d
     
     x := ($100 + c) << 1
     t := clkfreq / baud_rate
     d := cnt + t
     
     repeat 10
        outa[1] := x & 1
        waitcnt(d)
        x >>= 1
        d += t
     
pub Init(clk,rs,rw,e,db7,db4)

  sysclkfreq := clk
  _rs := rs
  _rw := rw
  _e := e
  _db7 := db7
  _db4 := db4
      
  outb[rs]~
  outb[rw]~
  outb[e]~
  outb[db7..db4]~

  dirb[rs]~~    
  dirb[rw]~~
  dirb[e]~~
  dirb[db7..db4]~~

  waitcnt(cnt + sysclkfreq / 10)
  
  inst8($30)
  usdelay(4100)
  inst8($30)
  usdelay(100)
  inst8($30)
  usdelay(100)
  inst8($28)   '4 bit mode
  usdelay(100)
  
  inst($28)  '4 bit mode,2 lines
  inst($c)   'display on ,cursor off,blink off
  inst(6)   'entry mode
  cls


pub print(m)|c

  repeat c from 0 to strsize(m)-1
     char(byte[m][c])

pub cursor(y,x)|q

  q := (y * $40) + x
  inst($80 + q)
  
PUB dec(value) | i, z

  if value < 0
    -value
    tx_out("-")

  i := 1_000_000_000
  z~

  repeat 10
    if value => i
      tx_out(value / i + "0")
      value //= i
      z~~
    elseif z or i == 1
      tx_out("0")
    i /= 10


PUB lcd_dec(value) | i, z

  if value < 0
    -value
    char("-")

  i := 1_000_000_000
  z~

  repeat 10
    if value => i
      char(value / i + "0")
      value //= i
      z~~
    elseif z or i == 1
      char("0")
    i /= 10


PUB hex(value, digits)

  value <<= (8 - digits) << 2
  repeat digits
    char(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))


PUB bin(value, digits)

  value <<= 32 - digits
  repeat digits
    char((value <-= 1) & 1 + "0")
    
pub cls

  inst(clearscreen)
  usdelay(2000)
  cursor(0,0)
    
pub char(c)

    outb[_rs]~~
    lcd4(c)

pub inst(c)

  outb[_rs]~
  lcd4(c)

pri inst8(d)

  outb[_rs]~
  outb[_db7.._db4] := d >> 4
  pulse
  
pri lcd4(d)

  ready
  outb[_db7.._db4] := d >> 4
  pulse
  ready
  outb[_db7.._db4] := d
  pulse

pri pulse

    outb[_e]~~
    outb[_e]~

PUB usDelay( Delay )

  waitcnt( ((sysclkfreq / 1_000_000) * Delay) + cnt)

pri ready|x

    usdelay(50)
      